#include <iostream>
#include <cstring>
#include "temporalInstance.h"
#include "temporalProjection.h"
#include "lexScanner.h"

using namespace std;

//Get the solution file name from the instance file name by
//	adding a "_SOLUTION" postfix tot he file name
void setSolutionFileName
(char * solutionFileName, const char *instanceFileName, const int MAX_NAME_LENGTH);

void main()
{
	TemporalInstance myInstance;
	myInstance.ReadInstanceFromFile("testInstance.txt");
	myInstance.Display();

	TemporalSolver mySolver;
	TemporalSolver::Solution mySolution;
	mySolver.GetTemporalSolverSolution(myInstance, mySolution);
	mySolver.DisplaySolution(mySolution);
	mySolver.WriteSolutionToFile(mySolution, "testInstance_Solution.txt");

	const int MAX_NAME_LENGTH = 40;
	char instanceFileName[MAX_NAME_LENGTH] = "testInstance.txt";
	char solutionFileName[MAX_NAME_LENGTH+10];
	bool keepGoing = true;
	while ( keepGoing ) 
	{
		cout << endl << endl
			 << " What is the file name of the next temporal instance? " << endl
			 << " (type QUIT to quit the program)";
		cin >> instanceFileName;
		if ( strcmp(instanceFileName,"QUIT") == 0 )
			keepGoing = false;
		else
		{
			if ( myInstance.ReadInstanceFromFile(instanceFileName) )
			{
				myInstance.Display();
				mySolver.GetTemporalSolverSolution(myInstance, mySolution);
				mySolver.DisplaySolution(mySolution);
				setSolutionFileName(solutionFileName, instanceFileName, MAX_NAME_LENGTH);
				mySolver.WriteSolutionToFile(mySolution, solutionFileName);
			}
			else
				cout	<< endl 
						<< " Fail to read a new instance from " << instanceFileName
						<< endl << endl;

		}
	}
}

//Get the solution file name from the instance file name by
//	adding a "_SOLUTION" postfix tot he file name
void setSolutionFileName
(char * solutionFileName, const char *instanceFileName, const int MAX_NAME_LENGTH)
{
	bool isExtensionFound;
	isExtensionFound = false;
	int i, j;
	for (	i=0, j=0; 
			i<MAX_NAME_LENGTH && instanceFileName[i]!=NULL; 
			i++, j++
		)
	{	if ( instanceFileName[i] == '.')
		{	solutionFileName[j++ ]='_';
			solutionFileName[j++ ]='S';
			solutionFileName[j++ ]='o';
			solutionFileName[j++ ]='l';
			solutionFileName[j++ ]='u';
			solutionFileName[j++ ]='t';
			solutionFileName[j++ ]='i';
			solutionFileName[j++ ]='o';
			solutionFileName[j++ ]='n';

			isExtensionFound = true;
		}
		
		solutionFileName[j ] = instanceFileName[i];
		
	}

	if (isExtensionFound == false)
		{	solutionFileName[j++ ]='_';
			solutionFileName[j++ ]='S';
			solutionFileName[j++ ]='O';
			solutionFileName[j++ ]='L';
			solutionFileName[j++ ]='U';
			solutionFileName[j++ ]='T';
			solutionFileName[j++ ]='I';
			solutionFileName[j++ ]='O';
			solutionFileName[j++ ]='N';
		}

	solutionFileName[j] = NULL;
}